#ifndef FAMILLES_PROTOCOLE_H
#define FAMILLES_PROTOCOLE_H

#include "Incopiable.h"
#include <vector>
#include <utility>

namespace SocketsFlux
{
   //
   // Abstractions
   //
   enum FamilleProtocole
   {
      IpV4, Tcp, Udp, IpV6 // il y en a plein d'autres
   };

   //
   // Singleton de soutien
   //
   class GestionnaireProtocoles
      : Incopiable
   {
   public:
      typedef int protocole_type;
      class Introuvable {};
   private:
      typedef std::pair<FamilleProtocole,protocole_type> Correspondance;
      std::vector<Correspondance> corresp_;
      GestionnaireProtocoles();
      static GestionnaireProtocoles singleton;
   public:
      static GestionnaireProtocoles &get() throw()
         { return singleton; }
      protocole_type trouver(const FamilleProtocole) const; // throw (Introuvable);
      ~GestionnaireProtocoles() throw();
   };
}

#endif
